#include <U8g2lib.h>
#include <Wire.h>
#include <ESP32Servo.h>
Servo myServo;

#define sPin D8
#define PULSEMIN 500
#define PULSEMAX 2500

int pos = 180;
long dt;
long vert;

U8G2_SSD1306_128X64_NONAME_F_HW_I2C u8g2(U8G2_R0, U8X8_PIN_NONE);

// void displayText(){
//   //u8g2.clearBuffer();
//   u8g2.setFontMode(1);
//   u8g2.setBitmapMode(1);
//   u8g2.setFont(u8g2_font_6x12_tr);
//   u8g2.drawStr(4,13,"Hello!");
//   u8g2.sendBuffer();
// }

void mouth_open(){
  u8g2.clearBuffer();
  u8g2.setFontMode(1);
  u8g2.setBitmapMode(1);
  u8g2.drawFilledEllipse(83, 33+vert, 8, 13);
  u8g2.drawFilledEllipse(62, 54+vert, 8, 6);
  u8g2.drawFilledEllipse(41, 33+vert, 8, 13);
  u8g2.sendBuffer();
}

void mouth_half_open (){
  u8g2.clearBuffer();
  u8g2.setFontMode(1);
  u8g2.setBitmapMode(1);
  u8g2.drawFilledEllipse(83, 33+vert, 8, 13);
  u8g2.drawFilledEllipse(41, 33+vert, 8, 13);
  u8g2.drawFilledEllipse(62, 57+vert, 8, 3);
  u8g2.sendBuffer();
} 

void mouth_closed (){
  u8g2.clearBuffer();
  u8g2.setFontMode(1);
  u8g2.setBitmapMode(1);
  u8g2.drawFilledEllipse(83, 33+vert, 8, 13);
  u8g2.drawFilledEllipse(62, 59+vert, 8, 1);
  u8g2.drawFilledEllipse(41, 33+vert, 8, 13);
  u8g2.sendBuffer();
}

void setup(){
  Serial.begin(115200);
  if (!u8g2.begin()){
    Serial.println("Display not initialized");
    for(;;);
  }
  delay(1000);
  Serial.println("Display initialized");

  pinMode (sPin, OUTPUT);
  ESP32PWM::allocateTimer(0);
  myServo.attach (sPin, PULSEMIN, PULSEMAX);

}

void loop(){
  vert = random(0,3);
  dt = random(0,150);

  // To sweep
  for (pos=0; pos<=180; pos+=1){
    myServo.write(pos);
    Serial.print("Servo position: ");
    Serial.println(pos);
    delay(15);
  }

    mouth_closed();
    delay(dt);
    // Serial.println(dt);

    vert = random(0,3);
    dt = random(0,200);
    mouth_half_open();
    delay(dt);
    // Serial.println(dt);

    vert = random(0,3);
    dt = random(0,200);
    mouth_open();
    delay(dt);
    // Serial.println(dt);

  delay(1000); //Stops for a second after reaching 180 degree

  for (pos=180; pos>=0; pos-=1) {
    myServo.write(pos);
    Serial.print("Servo position: ");
    Serial.println(pos);
    delay(15); 
  }

  delay(1000); //Stops for a second after reaching 0 degree

  // displayText();
  // face()
  

  vert = random(0,3);
  dt = random(0,200);
  mouth_half_open();
  delay(dt);
  // Serial.println(dt);

  vert = random(0,3);
  dt = random(0,200);
  mouth_closed();
  delay(dt);
  // Serial.println(dt);
}
